﻿module AccessibilityModifiers

//====================================================
// Подробное описание программного кода исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================


type AccessibilityModifier(len: int) as m =
    let mutable readonlyprop: int = 200
    let mutable privateprop: int = 0
    do m.ReadOnlyProperty <- len

    // Изменение свойства можно осуществить только внутри класса.
    // Для внешнего доступа это свойство только для чтения.
    member x.ReadOnlyProperty
        with get () = readonlyprop
        and private set v =
            if v < 1 then readonlyprop <- 1
            else if v > 500 then readonlyprop <- 500
            else readonlyprop <- v

    member x.PrivateProperty
        with private get () = privateprop
        and private set (value) =
            if value > 1000 then
                privateprop <- 1000
            else
                privateprop <- value
        